"use strict";
/*
 * Copyright (c) 2014-2023 Bjoern Kimminich & the OWASP Juice Shop contributors.
 * SPDX-License-Identifier: MIT
 */
Object.defineProperty(exports, "__esModule", { value: true });
const frisby = require("frisby");
const Joi = frisby.Joi;
const utils = require('../../lib/utils');
const REST_URL = 'http://localhost:42000/rest/admin';
describe('/rest/admin/application-version', () => {
    it('GET application version from package.json', () => {
        return frisby.get(REST_URL + '/application-version')
            .expect('status', 200)
            .expect('header', 'content-type', /application\/json/)
            .expect('json', {
            version: utils.version()
        });
    });
});
describe('/rest/admin/application-configuration', () => {
    it('GET application configuration', () => {
        return frisby.get(REST_URL + '/application-configuration')
            .expect('status', 200)
            .expect('header', 'content-type', /application\/json/)
            .expect('jsonTypes', {
            config: Joi.object()
        });
    });
});
//# sourceMappingURL=administrationApiSpec.js.map