/*!
This file is part of CycloneDX JavaScript Library.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

SPDX-License-Identifier: Apache-2.0
Copyright (c) OWASP Foundation. All Rights Reserved.
*/
import type { PositiveInteger } from '../types';
import { ComponentRepository } from './component';
import { Metadata } from './metadata';
import { VulnerabilityRepository } from './vulnerability';
export interface OptionalBomProperties {
    metadata?: Bom['metadata'];
    components?: Bom['components'];
    version?: Bom['version'];
    vulnerabilities?: Bom['vulnerabilities'];
    serialNumber?: Bom['serialNumber'];
}
export declare class Bom {
    #private;
    metadata: Metadata;
    components: ComponentRepository;
    vulnerabilities: VulnerabilityRepository;
    /**
     * @throws {@link TypeError} if `op.version` is neither {@link PositiveInteger} nor `undefined`
     */
    constructor(op?: OptionalBomProperties);
    get version(): PositiveInteger;
    /**
     * @throws {@link TypeError} if value is not {@link PositiveInteger}
     */
    set version(value: PositiveInteger);
    get serialNumber(): string | undefined;
    set serialNumber(value: string | undefined);
}
//# sourceMappingURL=bom.d.ts.map