/*!
This file is part of CycloneDX JavaScript Library.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

SPDX-License-Identifier: Apache-2.0
Copyright (c) OWASP Foundation. All Rights Reserved.
*/
import type { Bom } from '../models';
import type { NormalizerOptions, Serializer, SerializerOptions } from './types';
export declare abstract class BaseSerializer<NormalizedBom> implements Serializer {
    #private;
    /**
     * @readonly
     * @throws {@link Error}
     */
    serialize(bom: Bom, options?: SerializerOptions & NormalizerOptions): string;
    /**
     * @throws {@link Error}
     */
    protected abstract _normalize(bom: Bom, options?: NormalizerOptions): NormalizedBom;
    /**
     * @throws {@link Error}
     */
    protected abstract _serialize(normalizedBom: NormalizedBom, options?: SerializerOptions): string;
}
//# sourceMappingURL=baseSerializer.d.ts.map