"use strict";
/*!
This file is part of CycloneDX JavaScript Library.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

SPDX-License-Identifier: Apache-2.0
Copyright (c) OWASP Foundation. All Rights Reserved.
*/
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _BaseSerializer_instances, _BaseSerializer_getAllBomRefs, _BaseSerializer_normalize;
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseSerializer = void 0;
const tree_1 = require("../_helpers/tree");
const bomRefDiscriminator_1 = require("./bomRefDiscriminator");
class BaseSerializer {
    constructor() {
        _BaseSerializer_instances.add(this);
    }
    serialize(bom, options) {
        return this._serialize(__classPrivateFieldGet(this, _BaseSerializer_instances, "m", _BaseSerializer_normalize).call(this, bom, options), options);
    }
}
exports.BaseSerializer = BaseSerializer;
_BaseSerializer_instances = new WeakSet(), _BaseSerializer_getAllBomRefs = function* _BaseSerializer_getAllBomRefs(bom) {
    if (bom.metadata.component !== undefined) {
        yield bom.metadata.component.bomRef;
        for (const { bomRef } of bom.metadata.component.components[tree_1.treeIteratorSymbol]()) {
            yield bomRef;
        }
    }
    for (const { bomRef } of bom.components[tree_1.treeIteratorSymbol]()) {
        yield bomRef;
    }
    for (const { bomRef } of bom.vulnerabilities) {
        yield bomRef;
    }
}, _BaseSerializer_normalize = function _BaseSerializer_normalize(bom, options) {
    const bomRefDiscriminator = new bomRefDiscriminator_1.BomRefDiscriminator(__classPrivateFieldGet(this, _BaseSerializer_instances, "m", _BaseSerializer_getAllBomRefs).call(this, bom));
    bomRefDiscriminator.discriminate();
    try {
        return this._normalize(bom, options);
    }
    finally {
        bomRefDiscriminator.reset();
    }
};
//# sourceMappingURL=baseSerializer.js.map