"use strict";
/*!
This file is part of CycloneDX JavaScript Library.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

SPDX-License-Identifier: Apache-2.0
Copyright (c) OWASP Foundation. All Rights Reserved.
*/
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _BomRefDiscriminator_instances, _BomRefDiscriminator_originalValues, _BomRefDiscriminator_prefix, _BomRefDiscriminator_makeUniqueId;
Object.defineProperty(exports, "__esModule", { value: true });
exports.BomRefDiscriminator = void 0;
class BomRefDiscriminator {
    constructor(bomRefs, prefix = 'BomRef') {
        _BomRefDiscriminator_instances.add(this);
        _BomRefDiscriminator_originalValues.set(this, void 0);
        _BomRefDiscriminator_prefix.set(this, void 0);
        __classPrivateFieldSet(this, _BomRefDiscriminator_originalValues, new Map(Array.from(bomRefs, r => [r, r.value])), "f");
        __classPrivateFieldSet(this, _BomRefDiscriminator_prefix, prefix, "f");
    }
    get prefix() {
        return __classPrivateFieldGet(this, _BomRefDiscriminator_prefix, "f");
    }
    [(_BomRefDiscriminator_originalValues = new WeakMap(), _BomRefDiscriminator_prefix = new WeakMap(), _BomRefDiscriminator_instances = new WeakSet(), Symbol.iterator)]() {
        return __classPrivateFieldGet(this, _BomRefDiscriminator_originalValues, "f").keys();
    }
    discriminate() {
        const knownRefValues = new Set(['']);
        for (const [bomRef] of __classPrivateFieldGet(this, _BomRefDiscriminator_originalValues, "f")) {
            let value = bomRef.value;
            if (value === undefined || knownRefValues.has(value)) {
                value = __classPrivateFieldGet(this, _BomRefDiscriminator_instances, "m", _BomRefDiscriminator_makeUniqueId).call(this);
                bomRef.value = value;
            }
            knownRefValues.add(value);
        }
    }
    reset() {
        for (const [bomRef, originalValue] of __classPrivateFieldGet(this, _BomRefDiscriminator_originalValues, "f")) {
            bomRef.value = originalValue;
        }
    }
}
exports.BomRefDiscriminator = BomRefDiscriminator;
_BomRefDiscriminator_makeUniqueId = function _BomRefDiscriminator_makeUniqueId() {
    return `${__classPrivateFieldGet(this, _BomRefDiscriminator_prefix, "f")}${Math.random().toString(32).substring(1)}${Math.random().toString(32).substring(1)}`;
};
//# sourceMappingURL=bomRefDiscriminator.js.map