"use strict";
/*!
This file is part of CycloneDX JavaScript Library.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

SPDX-License-Identifier: Apache-2.0
Copyright (c) OWASP Foundation. All Rights Reserved.
*/
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _JsonSerializer_normalizerFactory;
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonSerializer = void 0;
const spec_1 = require("../spec");
const baseSerializer_1 = require("./baseSerializer");
class JsonSerializer extends baseSerializer_1.BaseSerializer {
    constructor(normalizerFactory) {
        if (!normalizerFactory.spec.supportsFormat(spec_1.Format.JSON)) {
            throw new spec_1.UnsupportedFormatError('Spec does not support JSON format.');
        }
        super();
        _JsonSerializer_normalizerFactory.set(this, void 0);
        __classPrivateFieldSet(this, _JsonSerializer_normalizerFactory, normalizerFactory, "f");
    }
    get normalizerFactory() {
        return __classPrivateFieldGet(this, _JsonSerializer_normalizerFactory, "f");
    }
    _normalize(bom, options = {}) {
        return __classPrivateFieldGet(this, _JsonSerializer_normalizerFactory, "f").makeForBom()
            .normalize(bom, options);
    }
    _serialize(bom, { space } = {}) {
        return JSON.stringify(bom, null, space);
    }
}
exports.JsonSerializer = JsonSerializer;
_JsonSerializer_normalizerFactory = new WeakMap();
//# sourceMappingURL=jsonSerializer.js.map