"use strict";
/*!
This file is part of CycloneDX JavaScript Library.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

SPDX-License-Identifier: Apache-2.0
Copyright (c) OWASP Foundation. All Rights Reserved.
*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.XmlSchema = void 0;
var XmlSchema;
(function (XmlSchema) {
    const _AnyUriSchemePattern = /^[a-z][a-z0-9+\-.]*$/i;
    function isAnyURI(value) {
        if (typeof value !== 'string') {
            return false;
        }
        if (value.length === 0) {
            return false;
        }
        const fragmentPos = value.indexOf('#');
        let beforeFragment;
        if (fragmentPos >= 0) {
            if (value.includes('#', fragmentPos + 1)) {
                return false;
            }
            beforeFragment = value.slice(undefined, fragmentPos);
        }
        else {
            beforeFragment = value;
        }
        const schemePos = beforeFragment.indexOf(':');
        if (schemePos >= 0) {
            if (!_AnyUriSchemePattern.test(beforeFragment.slice(undefined, schemePos))) {
                return false;
            }
        }
        return true;
    }
    XmlSchema.isAnyURI = isAnyURI;
})(XmlSchema || (exports.XmlSchema = XmlSchema = {}));
//# sourceMappingURL=types.js.map