"use strict";
/*!
This file is part of CycloneDX JavaScript Library.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

SPDX-License-Identifier: Apache-2.0
Copyright (c) OWASP Foundation. All Rights Reserved.
*/
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __Spec_version, __Spec_formats, __Spec_componentTypes, __Spec_hashAlgorithms, __Spec_hashValuePattern, __Spec_externalReferenceTypes, __Spec_vulnerabilityRatingMethods, __Spec_supportsDependencyGraph, __Spec_supportsToolReferences, __Spec_requiresComponentVersion, __Spec_supportsProperties, __Spec_supportsVulnerabilities, __Spec_supportsComponentEvidence, __Spec_supportsMetadataLifecycles;
Object.defineProperty(exports, "__esModule", { value: true });
exports._Spec = void 0;
class _Spec {
    constructor(version, formats, componentTypes, hashAlgorithms, hashValuePattern, externalReferenceTypes, supportsDependencyGraph, supportsToolReferences, requiresComponentVersion, supportsProperties, supportsVulnerabilities, vulnerabilityRatingMethods, supportsComponentEvidence, supportsMetadataLifecycles) {
        __Spec_version.set(this, void 0);
        __Spec_formats.set(this, void 0);
        __Spec_componentTypes.set(this, void 0);
        __Spec_hashAlgorithms.set(this, void 0);
        __Spec_hashValuePattern.set(this, void 0);
        __Spec_externalReferenceTypes.set(this, void 0);
        __Spec_vulnerabilityRatingMethods.set(this, void 0);
        __Spec_supportsDependencyGraph.set(this, void 0);
        __Spec_supportsToolReferences.set(this, void 0);
        __Spec_requiresComponentVersion.set(this, void 0);
        __Spec_supportsProperties.set(this, void 0);
        __Spec_supportsVulnerabilities.set(this, void 0);
        __Spec_supportsComponentEvidence.set(this, void 0);
        __Spec_supportsMetadataLifecycles.set(this, void 0);
        __classPrivateFieldSet(this, __Spec_version, version, "f");
        __classPrivateFieldSet(this, __Spec_formats, new Set(formats), "f");
        __classPrivateFieldSet(this, __Spec_componentTypes, new Set(componentTypes), "f");
        __classPrivateFieldSet(this, __Spec_hashAlgorithms, new Set(hashAlgorithms), "f");
        __classPrivateFieldSet(this, __Spec_hashValuePattern, hashValuePattern, "f");
        __classPrivateFieldSet(this, __Spec_externalReferenceTypes, new Set(externalReferenceTypes), "f");
        __classPrivateFieldSet(this, __Spec_supportsDependencyGraph, supportsDependencyGraph, "f");
        __classPrivateFieldSet(this, __Spec_supportsToolReferences, supportsToolReferences, "f");
        __classPrivateFieldSet(this, __Spec_requiresComponentVersion, requiresComponentVersion, "f");
        __classPrivateFieldSet(this, __Spec_supportsProperties, supportsProperties, "f");
        __classPrivateFieldSet(this, __Spec_supportsVulnerabilities, supportsVulnerabilities, "f");
        __classPrivateFieldSet(this, __Spec_vulnerabilityRatingMethods, new Set(vulnerabilityRatingMethods), "f");
        __classPrivateFieldSet(this, __Spec_supportsComponentEvidence, supportsComponentEvidence, "f");
        __classPrivateFieldSet(this, __Spec_supportsMetadataLifecycles, supportsMetadataLifecycles, "f");
    }
    get version() {
        return __classPrivateFieldGet(this, __Spec_version, "f");
    }
    supportsFormat(f) {
        return __classPrivateFieldGet(this, __Spec_formats, "f").has(f);
    }
    supportsComponentType(ct) {
        return __classPrivateFieldGet(this, __Spec_componentTypes, "f").has(ct);
    }
    supportsHashAlgorithm(ha) {
        return __classPrivateFieldGet(this, __Spec_hashAlgorithms, "f").has(ha);
    }
    supportsHashValue(hv) {
        return typeof hv === 'string' &&
            __classPrivateFieldGet(this, __Spec_hashValuePattern, "f").test(hv);
    }
    supportsExternalReferenceType(ert) {
        return __classPrivateFieldGet(this, __Spec_externalReferenceTypes, "f").has(ert);
    }
    get supportsDependencyGraph() {
        return __classPrivateFieldGet(this, __Spec_supportsDependencyGraph, "f");
    }
    get supportsToolReferences() {
        return __classPrivateFieldGet(this, __Spec_supportsToolReferences, "f");
    }
    get requiresComponentVersion() {
        return __classPrivateFieldGet(this, __Spec_requiresComponentVersion, "f");
    }
    supportsProperties() {
        return __classPrivateFieldGet(this, __Spec_supportsProperties, "f");
    }
    get supportsVulnerabilities() {
        return __classPrivateFieldGet(this, __Spec_supportsVulnerabilities, "f");
    }
    supportsVulnerabilityRatingMethod(rm) {
        return __classPrivateFieldGet(this, __Spec_vulnerabilityRatingMethods, "f").has(rm);
    }
    get supportsComponentEvidence() {
        return __classPrivateFieldGet(this, __Spec_supportsComponentEvidence, "f");
    }
    get supportsMetadataLifecycles() {
        return __classPrivateFieldGet(this, __Spec_supportsMetadataLifecycles, "f");
    }
}
exports._Spec = _Spec;
__Spec_version = new WeakMap(), __Spec_formats = new WeakMap(), __Spec_componentTypes = new WeakMap(), __Spec_hashAlgorithms = new WeakMap(), __Spec_hashValuePattern = new WeakMap(), __Spec_externalReferenceTypes = new WeakMap(), __Spec_vulnerabilityRatingMethods = new WeakMap(), __Spec_supportsDependencyGraph = new WeakMap(), __Spec_supportsToolReferences = new WeakMap(), __Spec_requiresComponentVersion = new WeakMap(), __Spec_supportsProperties = new WeakMap(), __Spec_supportsVulnerabilities = new WeakMap(), __Spec_supportsComponentEvidence = new WeakMap(), __Spec_supportsMetadataLifecycles = new WeakMap();
//# sourceMappingURL=_protocol.js.map