"use strict";
/*!
This file is part of CycloneDX JavaScript Library.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

SPDX-License-Identifier: Apache-2.0
Copyright (c) OWASP Foundation. All Rights Reserved.
*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.SpecVersionDict = exports.Spec1dot5 = exports.Spec1dot4 = exports.Spec1dot3 = exports.Spec1dot2 = void 0;
const enums_1 = require("../enums");
const _protocol_1 = require("./_protocol");
const enums_2 = require("./enums");
exports.Spec1dot2 = Object.freeze(new _protocol_1._Spec(enums_2.Version.v1dot2, [
    enums_2.Format.XML,
    enums_2.Format.JSON
], [
    enums_1.ComponentType.Application,
    enums_1.ComponentType.Framework,
    enums_1.ComponentType.Library,
    enums_1.ComponentType.Container,
    enums_1.ComponentType.OperatingSystem,
    enums_1.ComponentType.Device,
    enums_1.ComponentType.Firmware,
    enums_1.ComponentType.File
], [
    enums_1.HashAlgorithm.MD5,
    enums_1.HashAlgorithm['SHA-1'],
    enums_1.HashAlgorithm['SHA-256'],
    enums_1.HashAlgorithm['SHA-384'],
    enums_1.HashAlgorithm['SHA-512'],
    enums_1.HashAlgorithm['SHA3-256'],
    enums_1.HashAlgorithm['SHA3-384'],
    enums_1.HashAlgorithm['SHA3-512'],
    enums_1.HashAlgorithm['BLAKE2b-256'],
    enums_1.HashAlgorithm['BLAKE2b-384'],
    enums_1.HashAlgorithm['BLAKE2b-512'],
    enums_1.HashAlgorithm.BLAKE3
], /^([a-fA-F0-9]{32})$|^([a-fA-F0-9]{40})$|^([a-fA-F0-9]{64})$|^([a-fA-F0-9]{96})$|^([a-fA-F0-9]{128})$/, [
    enums_1.ExternalReferenceType.VCS,
    enums_1.ExternalReferenceType.IssueTracker,
    enums_1.ExternalReferenceType.Website,
    enums_1.ExternalReferenceType.Advisories,
    enums_1.ExternalReferenceType.BOM,
    enums_1.ExternalReferenceType.MailingList,
    enums_1.ExternalReferenceType.Social,
    enums_1.ExternalReferenceType.Chat,
    enums_1.ExternalReferenceType.Documentation,
    enums_1.ExternalReferenceType.Support,
    enums_1.ExternalReferenceType.Distribution,
    enums_1.ExternalReferenceType.License,
    enums_1.ExternalReferenceType.BuildMeta,
    enums_1.ExternalReferenceType.BuildSystem,
    enums_1.ExternalReferenceType.Other
], true, false, true, false, false, [], false, false));
exports.Spec1dot3 = Object.freeze(new _protocol_1._Spec(enums_2.Version.v1dot3, [
    enums_2.Format.XML,
    enums_2.Format.JSON
], [
    enums_1.ComponentType.Application,
    enums_1.ComponentType.Framework,
    enums_1.ComponentType.Library,
    enums_1.ComponentType.Container,
    enums_1.ComponentType.OperatingSystem,
    enums_1.ComponentType.Device,
    enums_1.ComponentType.Firmware,
    enums_1.ComponentType.File
], [
    enums_1.HashAlgorithm.MD5,
    enums_1.HashAlgorithm['SHA-1'],
    enums_1.HashAlgorithm['SHA-256'],
    enums_1.HashAlgorithm['SHA-384'],
    enums_1.HashAlgorithm['SHA-512'],
    enums_1.HashAlgorithm['SHA3-256'],
    enums_1.HashAlgorithm['SHA3-384'],
    enums_1.HashAlgorithm['SHA3-512'],
    enums_1.HashAlgorithm['BLAKE2b-256'],
    enums_1.HashAlgorithm['BLAKE2b-384'],
    enums_1.HashAlgorithm['BLAKE2b-512'],
    enums_1.HashAlgorithm.BLAKE3
], /^([a-fA-F0-9]{32})$|^([a-fA-F0-9]{40})$|^([a-fA-F0-9]{64})$|^([a-fA-F0-9]{96})$|^([a-fA-F0-9]{128})$/, [
    enums_1.ExternalReferenceType.VCS,
    enums_1.ExternalReferenceType.IssueTracker,
    enums_1.ExternalReferenceType.Website,
    enums_1.ExternalReferenceType.Advisories,
    enums_1.ExternalReferenceType.BOM,
    enums_1.ExternalReferenceType.MailingList,
    enums_1.ExternalReferenceType.Social,
    enums_1.ExternalReferenceType.Chat,
    enums_1.ExternalReferenceType.Documentation,
    enums_1.ExternalReferenceType.Support,
    enums_1.ExternalReferenceType.Distribution,
    enums_1.ExternalReferenceType.License,
    enums_1.ExternalReferenceType.BuildMeta,
    enums_1.ExternalReferenceType.BuildSystem,
    enums_1.ExternalReferenceType.Other
], true, false, true, true, false, [], true, false));
exports.Spec1dot4 = Object.freeze(new _protocol_1._Spec(enums_2.Version.v1dot4, [
    enums_2.Format.XML,
    enums_2.Format.JSON
], [
    enums_1.ComponentType.Application,
    enums_1.ComponentType.Framework,
    enums_1.ComponentType.Library,
    enums_1.ComponentType.Container,
    enums_1.ComponentType.OperatingSystem,
    enums_1.ComponentType.Device,
    enums_1.ComponentType.Firmware,
    enums_1.ComponentType.File
], [
    enums_1.HashAlgorithm.MD5,
    enums_1.HashAlgorithm['SHA-1'],
    enums_1.HashAlgorithm['SHA-256'],
    enums_1.HashAlgorithm['SHA-384'],
    enums_1.HashAlgorithm['SHA-512'],
    enums_1.HashAlgorithm['SHA3-256'],
    enums_1.HashAlgorithm['SHA3-384'],
    enums_1.HashAlgorithm['SHA3-512'],
    enums_1.HashAlgorithm['BLAKE2b-256'],
    enums_1.HashAlgorithm['BLAKE2b-384'],
    enums_1.HashAlgorithm['BLAKE2b-512'],
    enums_1.HashAlgorithm.BLAKE3
], /^([a-fA-F0-9]{32})$|^([a-fA-F0-9]{40})$|^([a-fA-F0-9]{64})$|^([a-fA-F0-9]{96})$|^([a-fA-F0-9]{128})$/, [
    enums_1.ExternalReferenceType.VCS,
    enums_1.ExternalReferenceType.IssueTracker,
    enums_1.ExternalReferenceType.Website,
    enums_1.ExternalReferenceType.Advisories,
    enums_1.ExternalReferenceType.BOM,
    enums_1.ExternalReferenceType.MailingList,
    enums_1.ExternalReferenceType.Social,
    enums_1.ExternalReferenceType.Chat,
    enums_1.ExternalReferenceType.Documentation,
    enums_1.ExternalReferenceType.Support,
    enums_1.ExternalReferenceType.Distribution,
    enums_1.ExternalReferenceType.License,
    enums_1.ExternalReferenceType.BuildMeta,
    enums_1.ExternalReferenceType.BuildSystem,
    enums_1.ExternalReferenceType.ReleaseNotes,
    enums_1.ExternalReferenceType.Other
], true, true, false, true, true, [
    enums_1.Vulnerability.RatingMethod.CVSSv2,
    enums_1.Vulnerability.RatingMethod.CVSSv3,
    enums_1.Vulnerability.RatingMethod.CVSSv31,
    enums_1.Vulnerability.RatingMethod.OWASP,
    enums_1.Vulnerability.RatingMethod.Other
], true, false));
exports.Spec1dot5 = Object.freeze(new _protocol_1._Spec(enums_2.Version.v1dot5, [
    enums_2.Format.XML,
    enums_2.Format.JSON
], [
    enums_1.ComponentType.Application,
    enums_1.ComponentType.Framework,
    enums_1.ComponentType.Library,
    enums_1.ComponentType.Container,
    enums_1.ComponentType.Platform,
    enums_1.ComponentType.OperatingSystem,
    enums_1.ComponentType.Device,
    enums_1.ComponentType.DeviceDriver,
    enums_1.ComponentType.Firmware,
    enums_1.ComponentType.File,
    enums_1.ComponentType.MachineLearningModel,
    enums_1.ComponentType.Data
], [
    enums_1.HashAlgorithm.MD5,
    enums_1.HashAlgorithm['SHA-1'],
    enums_1.HashAlgorithm['SHA-256'],
    enums_1.HashAlgorithm['SHA-384'],
    enums_1.HashAlgorithm['SHA-512'],
    enums_1.HashAlgorithm['SHA3-256'],
    enums_1.HashAlgorithm['SHA3-384'],
    enums_1.HashAlgorithm['SHA3-512'],
    enums_1.HashAlgorithm['BLAKE2b-256'],
    enums_1.HashAlgorithm['BLAKE2b-384'],
    enums_1.HashAlgorithm['BLAKE2b-512'],
    enums_1.HashAlgorithm.BLAKE3
], /^([a-fA-F0-9]{32})$|^([a-fA-F0-9]{40})$|^([a-fA-F0-9]{64})$|^([a-fA-F0-9]{96})$|^([a-fA-F0-9]{128})$/, [
    enums_1.ExternalReferenceType.VCS,
    enums_1.ExternalReferenceType.IssueTracker,
    enums_1.ExternalReferenceType.Website,
    enums_1.ExternalReferenceType.Advisories,
    enums_1.ExternalReferenceType.BOM,
    enums_1.ExternalReferenceType.MailingList,
    enums_1.ExternalReferenceType.Social,
    enums_1.ExternalReferenceType.Chat,
    enums_1.ExternalReferenceType.Documentation,
    enums_1.ExternalReferenceType.Support,
    enums_1.ExternalReferenceType.Distribution,
    enums_1.ExternalReferenceType.DistributionIntake,
    enums_1.ExternalReferenceType.License,
    enums_1.ExternalReferenceType.BuildMeta,
    enums_1.ExternalReferenceType.BuildSystem,
    enums_1.ExternalReferenceType.ReleaseNotes,
    enums_1.ExternalReferenceType.SecurityContact,
    enums_1.ExternalReferenceType.ModelCard,
    enums_1.ExternalReferenceType.Log,
    enums_1.ExternalReferenceType.Configuration,
    enums_1.ExternalReferenceType.Evidence,
    enums_1.ExternalReferenceType.Formulation,
    enums_1.ExternalReferenceType.Attestation,
    enums_1.ExternalReferenceType.ThreatModel,
    enums_1.ExternalReferenceType.AdversaryModel,
    enums_1.ExternalReferenceType.RiskAssessment,
    enums_1.ExternalReferenceType.VulnerabilityAssertion,
    enums_1.ExternalReferenceType.ExploitabilityStatement,
    enums_1.ExternalReferenceType.PentestReport,
    enums_1.ExternalReferenceType.StaticAnalysisReport,
    enums_1.ExternalReferenceType.DynamicAnalysisReport,
    enums_1.ExternalReferenceType.RuntimeAnalysisReport,
    enums_1.ExternalReferenceType.ComponentAnalysisReport,
    enums_1.ExternalReferenceType.MaturityReport,
    enums_1.ExternalReferenceType.CertificationReport,
    enums_1.ExternalReferenceType.CodifiedInfrastructure,
    enums_1.ExternalReferenceType.QualityMetrics,
    enums_1.ExternalReferenceType.POAM,
    enums_1.ExternalReferenceType.Other
], true, true, false, true, true, [
    enums_1.Vulnerability.RatingMethod.CVSSv2,
    enums_1.Vulnerability.RatingMethod.CVSSv3,
    enums_1.Vulnerability.RatingMethod.CVSSv31,
    enums_1.Vulnerability.RatingMethod.CVSSv4,
    enums_1.Vulnerability.RatingMethod.OWASP,
    enums_1.Vulnerability.RatingMethod.SSVC,
    enums_1.Vulnerability.RatingMethod.Other
], true, true));
exports.SpecVersionDict = Object.freeze({
    [enums_2.Version.v1dot5]: exports.Spec1dot5,
    [enums_2.Version.v1dot4]: exports.Spec1dot4,
    [enums_2.Version.v1dot3]: exports.Spec1dot3,
    [enums_2.Version.v1dot2]: exports.Spec1dot2
});
//# sourceMappingURL=consts.js.map