/*!
This file is part of CycloneDX JavaScript Library.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

SPDX-License-Identifier: Apache-2.0
Copyright (c) OWASP Foundation. All Rights Reserved.
*/
import type { Comparable } from '../../_helpers/sortable';
import { SortableComparables } from '../../_helpers/sortable';
import type { AffectStatus } from '../../enums/vulnerability';
import type { BomLinkElement } from '../bomLink';
import type { BomRef } from '../bomRef';
export interface OptionalAffectProperties {
    versions?: Affect['versions'];
}
export declare class Affect implements Comparable<Affect> {
    ref: BomRef | BomLinkElement;
    versions: AffectedVersionRepository;
    constructor(ref: Affect['ref'], op?: OptionalAffectProperties);
    compare(other: Affect): number;
}
export declare class AffectRepository extends SortableComparables<Affect> {
}
export interface OptionalAffectedVersionProperties {
    status?: AffectedVersion['status'];
}
export declare class AffectedSingleVersion implements Comparable<AffectedSingleVersion> {
    version: string;
    status?: AffectStatus;
    constructor(version: string, op?: OptionalAffectedVersionProperties);
    compare(other: AffectedSingleVersion): number;
}
export declare class AffectedVersionRange implements Comparable<AffectedVersionRange> {
    range: string;
    status?: AffectStatus;
    constructor(range: string, op?: OptionalAffectedVersionProperties);
    compare(other: AffectedVersionRange): number;
}
export type AffectedVersion = AffectedSingleVersion | AffectedVersionRange;
export declare class AffectedVersionRepository extends SortableComparables<AffectedVersion> {
}
//# sourceMappingURL=affect.d.ts.map