/*!
This file is part of CycloneDX JavaScript Library.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

SPDX-License-Identifier: Apache-2.0
Copyright (c) OWASP Foundation. All Rights Reserved.
*/
import type { Comparable } from '../../_helpers/sortable';
import { SortableComparables } from '../../_helpers/sortable';
import type { RatingMethod, Severity } from '../../enums/vulnerability';
import type { Source } from './source';
export interface OptionalRatingProperties {
    source?: Rating['source'];
    score?: Rating['score'];
    severity?: Rating['severity'];
    method?: Rating['method'];
    vector?: Rating['vector'];
    justification?: Rating['justification'];
}
export declare class Rating implements Comparable<Rating> {
    source?: Source;
    score?: number;
    severity?: Severity;
    method?: RatingMethod;
    vector?: string;
    justification?: string;
    constructor(op?: OptionalRatingProperties);
    compare(other: Rating): number;
}
export declare class RatingRepository extends SortableComparables<Rating> {
}
//# sourceMappingURL=rating.d.ts.map